/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.3a Evaluation
Automatic Program Generator
 Copyright 1998-2011 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 28/08/2012
Author  : Freeware, for evaluation and
non-commercial use only
Company : 
Comments: 


Chip type               : ATmega8535
Program type            : Application
AVR Core Clock frequency: 4.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 128
*****************************************************/

#include <mega8535.h>

// Alphanumeric LCD functions
#include <alcd.h>

// Standard Input/Output functions
#include <stdio.h>

#include <delay.h>

// Definition
#define PORT_DHT PORTA
#define DDR_DHT DDRA
#define PIN_DHT PINA
#define PIN_DATA_DHT 0

// Declare your global variables here

void start_dht11()
{
        PORT_DHT &= ~(1 << PIN_DATA_DHT);       // Clear bit, output = low, input = tri-state
        DDR_DHT |= (1 << PIN_DATA_DHT);         // Set Bit, configure PIN_DHT as output
        delay_ms(18);                           // Period for ensuring DHT11 receive start signal
        DDR_DHT &= ~(1 << PIN_DATA_DHT);        // Clear bit, configure PIN_DHT as input
}

unsigned char read_dht11(unsigned char *int_rh, unsigned char *int_t)
{
        char read_loop = 0, read_loop2 = 0;
        unsigned char check_sum_data = 0;
        unsigned int check_sum_calc = 0;
        
                                                           
        while(PIN_DHT & (1 << PIN_DATA_DHT));           // 80 us low response signal from DHT11
        while(!(PIN_DHT & (1 << PIN_DATA_DHT)));        // 80 us high response signal from DHT11 
        
        for(read_loop = 0; read_loop < 5; read_loop++)
        {
                for(read_loop2 = 0; read_loop2 < 8; read_loop2++)
                {
                        while(PIN_DHT & (1 << PIN_DATA_DHT));           // 50 us start to transmit signal from DHT11 (low)
                        while(!(PIN_DHT & (1 << PIN_DATA_DHT)));        // Begin counting data signal length
                        TCNT0 = 0x00;
                        while(PIN_DHT & (1 << PIN_DATA_DHT));
                        if(TCNT0 > 0x0f)         // If high signal > 30 us then it's interpreted as "1"
                        {       
                                switch(read_loop)
                                {
                                        case 0:
                                        *int_rh |= (1 << 7-read_loop2); break;                    
                                        case 2:
                                        *int_t |= (1 << 7-read_loop2); break;
                                        case 4:                             
                                        check_sum_data |= (1 << 7-read_loop2); break;
                                }
                        }
                        else
                        {
                                switch(read_loop)
                                {
                                        case 0:
                                        *int_rh &= ~(1 << 7-read_loop2); break;                           
                                        case 2:
                                        *int_t &= ~(1 << 7-read_loop2); break;
                                        case 4:
                                        check_sum_data &= ~(1 << 7-read_loop2); break;
                                }
                        }
                }
        }        
        delay_us(50);           // Delay after last bit data transmitted
                                        
        // Calculating check sum value
        check_sum_calc = *int_rh + *int_t;
        check_sum_calc &= 0x00FF;
        
        if(check_sum_data == check_sum_calc)
                return 1;       // Check sum received from DHT11 = check sum calculated from *int_rh and *int_t 
        else
                return 0;       // Check sum error      
}

void main(void)
{
// Declare your local variables here
unsigned char rh_data, t_data;
unsigned char buff_conv[3];

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 500.000 kHz
// Mode: Normal top=0xFF
// OC0 output: Disconnected
TCCR0=0x02;
TCNT0=0x00;
OCR0=0x00;

// USART initialization; Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On; USART Transmitter: On
// USART Mode: Asynchronous; USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x18;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Alphanumeric LCD initialization
// Connections are specified in the
// Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
// RS - PORTC Bit 0
// RD - PORTC Bit 1
// EN - PORTC Bit 2
// D4 - PORTC Bit 4
// D5 - PORTC Bit 5
// D6 - PORTC Bit 6
// D7 - PORTC Bit 7
// Characters/line: 16
lcd_init(16);
lcd_gotoxy(0, 0);
lcd_puts("RH : ");
lcd_gotoxy(0, 1);
lcd_puts("T  : ");

while (1)
      {
      // Place your code here
          start_dht11();
          if(read_dht11(&rh_data, &t_data) == 1)
          {             
                lcd_gotoxy(6, 0);
                buff_conv[0] = rh_data / 100;
                if(buff_conv[0] > 0)
                        rh_data -= buff_conv[0] * 100;
                buff_conv[1] = rh_data / 10;
                if(buff_conv[0] > 0 || buff_conv[1] > 0)
                        rh_data -= buff_conv[1] * 10;
                buff_conv[2] = rh_data;
                
                lcd_putchar(48 + buff_conv[0]);
                lcd_putchar(48 + buff_conv[1]);
                lcd_putchar(48 + buff_conv[2]);
                lcd_puts("  ");
                
                lcd_gotoxy(6, 1);
                buff_conv[0] = t_data / 100;
                if(buff_conv[0] > 0)
                        t_data -= buff_conv[0] * 100;
                buff_conv[1] = t_data / 10;
                if(buff_conv[0] > 0 || buff_conv[1] > 0)
                        t_data -= buff_conv[1] * 10;
                buff_conv[2] = t_data;
                
                lcd_putchar(48 + buff_conv[0]);
                lcd_putchar(48 + buff_conv[1]);
                lcd_putchar(48 + buff_conv[2]);
                lcd_puts("  ");                          
          }     
          else
          {              
                lcd_gotoxy(6, 0);
                lcd_puts("error");
                lcd_gotoxy(6, 1);
                lcd_puts("error");
          }
          delay_ms(1000);
      }
}
